﻿/*
 * Creado por SharpDevelop.
 * Usuario: Jorge
 * Fecha: 20/04/2013
 * Hora: 13:53
 * 
 * Para cambiar esta plantilla use Herramientas | Opciones | Codificación | Editar Encabezados Estándar
 */
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.ComponentModel;

public class FormResizer
{
    float f_HeightRatio = new float();
    float f_WidthRatio = new float();
    public void ResizeForm(Form ObjForm, int DesignerWidth, int DesignerHeight)
    {
        #region Code for Resizing and Font Change According to Resolution
        int i_StandardHeight = DesignerHeight;
        int i_StandardWidth = DesignerWidth;
        int i_PresentHeight = Screen.PrimaryScreen.Bounds.Height;//Resolution Height
        int i_PresentWidth = Screen.PrimaryScreen.Bounds.Width;//Resolution Width
        f_HeightRatio = (float)((float)i_PresentHeight / (float)i_StandardHeight);
        f_WidthRatio = (float)((float)i_PresentWidth / (float)i_StandardWidth);
        ObjForm.AutoScaleMode = AutoScaleMode.None;
        ObjForm.Scale(new SizeF(f_WidthRatio, f_HeightRatio));

        foreach (Control c in ObjForm.Controls)
        {
            if (c.HasChildren)
            {
                ResizeControlStore(c);
            }
            else
            {
                c.Font = new Font(c.Font.FontFamily, c.Font.Size * f_HeightRatio, c.Font.Style, c.Font.Unit, ((byte)(0)));
            }
        }
        ObjForm.Font = new Font(ObjForm.Font.FontFamily, ObjForm.Font.Size * f_HeightRatio, ObjForm.Font.Style, ObjForm.Font.Unit, ((byte)(0)));
        #endregion
    }

    private void ResizeControlStore(Control objCtl)
    {
        if (objCtl.HasChildren)
        {
            foreach (Control cChildren in objCtl.Controls)
            {
                if (cChildren.HasChildren)
                {
                    ResizeControlStore(cChildren);
                }
                else
                {
                    cChildren.Font = new Font(cChildren.Font.FontFamily, cChildren.Font.Size * f_HeightRatio, cChildren.Font.Style, cChildren.Font.Unit, ((byte)(0)));
                }
            }
            objCtl.Font = new Font(objCtl.Font.FontFamily, objCtl.Font.Size * f_HeightRatio, objCtl.Font.Style, objCtl.Font.Unit, ((byte)(0)));
        }
        else
        {
            objCtl.Font = new Font(objCtl.Font.FontFamily, objCtl.Font.Size * f_HeightRatio, objCtl.Font.Style, objCtl.Font.Unit, ((byte)(0)));
        }
    }
}

